//---------------------------------------------------------------------------
#ifndef navimainH
#define navimainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include "rtklib.h"
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TButton *BtnStart;
	TButton *BtnStop;
	TButton *BtnExit;
	TButton *BtnOpt;
	TPanel *Panel1;
	TLabel *LabelTime;
	TTimer *Timer;
	TPanel *Str1;
	TPanel *Str2;
	TPanel *Str4;
	TPanel *Str3;
	TPanel *Svr;
	TPanel *Panel2;
	TPanel *Panel21;
	TLabel *Plabel0;
	TPanel *Panel22;
	TPanel *Panel3;
	TLabel *Message;
	TSpeedButton *BtnTimeSys;
	TSpeedButton *BtnSolType;
	TSpeedButton *BtnStr;
	TImage *Image1;
	TImage *Image2;
	TPanel *Panel211;
	TLabel *PlabelA;
	TLabel *Solution;
	TLabel *Plabel1;
	TLabel *Pos1;
	TLabel *Pos2;
	TLabel *Plabel2;
	TLabel *Plabel3;
	TLabel *Pos3;
	TLabel *LabelStd;
	TPanel *Str5;
	TPanel *Str6;
	TScrollBar *ScbSol;
	TSpeedButton *BtnMonitor;
	TLabel *Label1;
	TButton *BtnSave;
	TSaveDialog *SaveDialog;
	TImage *Disp;
	TImage *Plot;
	TPanel *IndSol;
	TLabel *LabelNSat;
	TSpeedButton *BtnAbout;
	TPanel *PanelFull;
	TImage *PlotFull;
	TImage *DispFull;
	TUpDown *UdScale;
	TSpeedButton *BtnPlotType;
	TSpeedButton *BtnPlotTypeFull;
	TButton *BtnSaveFull;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall BtnStartClick(TObject *Sender);
	void __fastcall BtnStopClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnStrClick(TObject *Sender);
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall BtnTimeSysClick(TObject *Sender);
	void __fastcall BtnSolTypeClick(TObject *Sender);
	void __fastcall BtnPlotTypeClick(TObject *Sender);
	void __fastcall BtnOptClick(TObject *Sender);
	void __fastcall BtnMonitorClick(TObject *Sender);
	void __fastcall UdScaleChangingEx(TObject *Sender, bool &AllowChange,
          short NewValue, TUpDownDirection Direction);
	void __fastcall ScbSolChange(TObject *Sender);
	void __fastcall BtnSaveClick(TObject *Sender);
	void __fastcall BtnAboutClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
private:
	int SvrCycle,SvrBuffSize,Scale,SolBuffSize,NavSelect,SbasSat,SavedSol;
	int Stream[MAXSTRRTK],Format[MAXSTRRTK],CmdEna[2][2],TimeSys,SolType,PlotType;
	int PSol,PSolS,PSolE,Nsat;
	int Sat[MAXSAT],Snr1[MAXSAT],Snr2[MAXSAT],Vsat[MAXSAT];
	double Az[MAXSAT],El[MAXSAT];
	gtime_t *Time;
	int *SolStat,*Nvsat;
	double *SolRov,*SolRef,*Qr,*VelRov,*Age,*Ratio;
	AnsiString Paths[MAXSTRRTK][3],Cmds[2][2];
	prcopt_t PrcOpt;
	solopt_t SolOpt;
	TFont *PosFont;
	int DebugTraceF,RovPosTypeF,RefPosTypeF,RovAntPcvF,RefAntPcvF;
	AnsiString RovAntF,RefAntF,AntPcvFileF,StaPosFileF,GoogleEarthFileF;
	double RovAntDel[3],RefAntDel[3],RovPos[3],RefPos[3];
	void __fastcall UpdateLog(int stat, gtime_t time, double *rr, double *qr,
		double *rb, int ns, double age, double ratio);
	void __fastcall UpdateTimeSys(void);
	void __fastcall UpdateSolType(void);
	void __fastcall UpdateFont(void);
	void __fastcall UpdateTime(void);
	void __fastcall UpdatePos(void);
	void __fastcall UpdateStr(void);
	void __fastcall UpdatePlot(void);
	void __fastcall ChangePlot(int dir);
	void __fastcall ExpandPlot(int dir);
	void __fastcall DrawSat(void);
	void __fastcall DrawSnr(void);
	void __fastcall DrawSky(void);
	void __fastcall DrawTrk(void);
	void __fastcall DrawTrkStat(int stat);
	void __fastcall DrawCircle(TCanvas *c, TPoint p, int r, TColor color1,
		TColor color2);
	void __fastcall DrawGrid(TCanvas *c, int w, int h, TPoint p, int gint,
		int ng, TColor color1, TColor color2);
	void __fastcall DrawText(TCanvas *c, int x, int y, AnsiString s,
		TColor color, int align);
	void __fastcall DrawArrow(TCanvas *c, TPoint p, int siz, int ang,
		TColor color);
	void __fastcall InitSolBuff(void);
	void __fastcall SaveLog(void);
	void __fastcall LoadNav(nav_t *nav);
	void __fastcall SaveNav(nav_t *nav);
public:
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
