//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "plotmain.h"
#include "plotopt.h"
#include "refdlg.h"
#include "rtklib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPlotOptDialog *PlotOptDialog;
//---------------------------------------------------------------------------
__fastcall TPlotOptDialog::TPlotOptDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::FormShow(TObject *Sender)
{
	char s1[64],s2[64];
	AnsiString s;
	TimeLabel->ItemIndex=Plot->TimeLabel;
	AutoScale->ItemIndex=Plot->AutoScale;
	ShowStats->ItemIndex=Plot->ShowStats;
	ShowArrow->ItemIndex=Plot->ShowArrow;
	ShowSlip ->ItemIndex=Plot->ShowSlip;
	ShowErr  ->ItemIndex=Plot->ShowErr;
	ShowEph  ->ItemIndex=Plot->ShowEph;
	EnaSbas  ->ItemIndex=Plot->EnaSbas;
	PlotStyle->ItemIndex=Plot->PlotStyle;
	int marks[]={1,2,3,4,5,10,15,20};
	for (int i=0;i<8;i++) {
		if (marks[i]==Plot->MarkSize) MarkSize->ItemIndex=i;
	}
	MColor1->Color=Plot->MColor[1];
	MColor2->Color=Plot->MColor[2];
	MColor3->Color=Plot->MColor[3];
	MColor4->Color=Plot->MColor[4];
	MColor5->Color=Plot->MColor[5];
	Color1->Color=Plot->CColor[0];
	Color2->Color=Plot->CColor[1];
	Color3->Color=Plot->CColor[2];
	Color4->Color=Plot->CColor[3];
	FontLabel->Font->Assign(Plot->Font);
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
	ElMask->Text=s.sprintf("%.0f",Plot->ElMask);
	YRange->Text=s.sprintf("%.2f",Plot->YRange);
	Origin->ItemIndex=Plot->Origin;
	RefPos1->Text=s.sprintf("%.9f",Plot->OOPos[0]*R2D);
	RefPos2->Text=s.sprintf("%.9f",Plot->OOPos[1]*R2D);
	RefPos3->Text=s.sprintf("%.4f",Plot->OOPos[2]);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnOKClick(TObject *Sender)
{

	Plot->TimeLabel=TimeLabel->ItemIndex;
	Plot->AutoScale=AutoScale->ItemIndex;
	Plot->ShowStats=ShowStats->ItemIndex;
	Plot->ShowArrow=ShowArrow->ItemIndex;
	Plot->ShowSlip=ShowSlip->ItemIndex;
	Plot->ShowErr=ShowErr->ItemIndex;
	Plot->ShowEph=ShowEph->ItemIndex;
	Plot->EnaSbas=EnaSbas->ItemIndex;
	Plot->PlotStyle=PlotStyle->ItemIndex;
	int marks[]={1,2,3,4,5,10,15,20};
	Plot->MarkSize=marks[MarkSize->ItemIndex];
	Plot->MColor[1]=MColor1->Color;
	Plot->MColor[2]=MColor2->Color;
	Plot->MColor[3]=MColor3->Color;
	Plot->MColor[4]=MColor4->Color;
	Plot->MColor[5]=MColor5->Color;
	Plot->CColor[0]=Color1->Color;
	Plot->CColor[1]=Color2->Color;
	Plot->CColor[2]=Color3->Color;
	Plot->CColor[3]=Color4->Color;
	Plot->Font->Assign(FontLabel->Font);
	Plot->ElMask=ElMask->Text.ToDouble();
	Plot->YRange=YRange->Text.ToDouble();
	Plot->Origin=Origin->ItemIndex;
	Plot->OOPos[0]=RefPos1->Text.ToDouble()*D2R;
	Plot->OOPos[1]=RefPos2->Text.ToDouble()*D2R;
	Plot->OOPos[2]=RefPos3->Text.ToDouble();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::MColorClick(TObject *Sender)
{
	TPanel *panel=(TPanel *)Sender;
	ColorDialog->Color=panel->Color;
	if (!ColorDialog->Execute()) return;
	panel->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor1Click(TObject *Sender)
{
	ColorDialog->Color=Color1->Color;
	if (!ColorDialog->Execute()) return;
	Color1->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor2Click(TObject *Sender)
{
	ColorDialog->Color=Color2->Color;
	if (!ColorDialog->Execute()) return;
	Color2->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor3Click(TObject *Sender)
{
	ColorDialog->Color=Color3->Color;
	if (!ColorDialog->Execute()) return;
	Color3->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor4Click(TObject *Sender)
{
	ColorDialog->Color=Color4->Color;
	if (!ColorDialog->Execute()) return;
	Color4->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnFontClick(TObject *Sender)
{
	AnsiString s;
	FontDialog->Font=FontLabel->Font;
	if (!FontDialog->Execute()) return;
	FontLabel->Font=FontDialog->Font;
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnRefPosClick(TObject *Sender)
{
	AnsiString s;
	RefDialog->RovPos[0]=RefPos1->Text.ToDouble();
	RefDialog->RovPos[1]=RefPos2->Text.ToDouble();
	RefDialog->RovPos[2]=RefPos3->Text.ToDouble();
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	RefDialog->BtnLoad->Enabled=true;
	if (RefDialog->ShowModal()!=mrOk) return;
	RefPos1->Text=s.sprintf("%.9f",RefDialog->Pos[0]);
	RefPos2->Text=s.sprintf("%.9f",RefDialog->Pos[1]);
	RefPos3->Text=s.sprintf("%.4f",RefDialog->Pos[2]);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::AutoScaleChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::OriginChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::UpdateEnable(void)
{
	RefPos1->Enabled=Origin->ItemIndex==4&&!Plot->RawObs;
	RefPos2->Enabled=Origin->ItemIndex==4&&!Plot->RawObs;
	RefPos3->Enabled=Origin->ItemIndex==4&&!Plot->RawObs;
	BtnRefPos->Enabled=Origin->ItemIndex==4&&!Plot->RawObs;
	ShowErr->Enabled=!Plot->RawObs;
	ShowArrow->Enabled=!Plot->RawObs;
	ShowSlip->Enabled=Plot->RawObs;
	ShowEph->Enabled=Plot->RawObs;
	EnaSbas->Enabled=Plot->RawObs;
	ElMask->Enabled=Plot->RawObs;
	AutoScale->Enabled=!Plot->RawObs;
	YRange->Enabled=!Plot->RawObs;
	Origin->Enabled=!Plot->RawObs;
}
//---------------------------------------------------------------------------
